/*
 * FILE: ST.h
 * AUTH: Soren Spies (sspies)
 * DATE: 5 Feb 2001
 * DESC: private include for STunnel package.
 *
 * Copyright (c) 2001 Soren Spies.
 * Please see included file COPYING for license details.
 * STunnel is available from http://www.techhouse.org/~soren/software
 */

#include "STunnel.h"

#define reterr(x) do { \
	if(errno) \
		dperror(x); \
	else \
		errprint(x "\n"); \
	return(STErr); \
	} while(0)

#define SSHSHELLCMD "echo bob; while true; do ps $PPID > /dev/null || exit; sleep 60; done"
#define NUMARGS 9	/* don't forget to null terminate :P */
#define TMPMASK "STunDelXXXXXXX"
#define LINECHARS 1024
#define KNOWNHOSTSSUFFIX "/.ssh/known_hosts"
#define TKFFMT "%s.tmp.%d"
#define KFFMT "%s%s"
#define DEBUG
#define SSH "/usr/bin/ssh"
#define LOCALBIND "-L"
#define REMOTEBIND "-R"
#define PORTFMT "%d:%s:%d"
#define USERHOSTFMT "%s@%s"
#define ARGSZ 256
#define PWSTR "password:"
#define PPSTR "passphrase for"
#define NEWKEYSTR "Are you sure you want to continue connecting (yes/no)?"
#define KEYCHANGEDSTR "HOST IDENTIFICATION HAS CHANGED!"
#define BOBSTR "bob\n"
#define YESSTR "yes\n"
#define NEWLINE "\n"
#define PERMDENIED "Permission denied"
#define BADPPHRASE "Bad passphrase."
/*#define UNKNOWNHOST "no address associated with hostname."*/
#define WARNING "Warning:"
#define ONEATTEMPTOPT "-o ConnectionAttempts 1"
#define ONEPROMPTOPT "-o NumberOfPasswordPrompts 1"
#define NORSHOPT "-o FallBackToRsh no"

enum STStates {
	Closed = 0,
	Open,
	NewKey,
	PPNeeded,
	Connected
};

typedef struct STConData {
    /* some stuff to maintain connection to ssh process */
	int pipe;		/* pipe to process */
	int pid;		/* pid of process */
	enum STStates state;
} STConData;
